
CREATE TABLE SRI_USER(
ID bigint NOT NULL  IDENTITY(1,1) ,
USERNAME varchar(255) NOT NULL ,
PASSWORD varchar(255) NULL ,
SALT varchar(250) NULL ,
ALGORITHM varchar(50) NULL ,
DEFAULT_STORE_ID varchar(255) NULL ,
PRIMARY KEY (ID),
CONSTRAINT AK_USER UNIQUE (USERNAME))
;

CREATE TABLE ACCESS_RULE(
RULE_NAME varchar(255) NOT NULL ,
PRIMARY KEY (RULE_NAME))
;

CREATE TABLE ACCESS_RULE_IMPLICIT(
RULE_NAME varchar(255) NOT NULL ,
IMPLIES_RULE_NAME varchar(255) NOT NULL ,
PRIMARY KEY (RULE_NAME,IMPLIES_RULE_NAME))
;

CREATE TABLE USER_PERMISSION(
ID bigint NOT NULL ,
RULE_NAME varchar(255) NOT NULL ,
PRIMARY KEY (ID,RULE_NAME))
;

CREATE TABLE MS_STORE(
STORE_ID varchar(255) NOT NULL ,
PRIMARY KEY (STORE_ID))
;

CREATE TABLE MS_STORE_USER(
STORE_ID varchar(255) NOT NULL ,
ID bigint NOT NULL ,
PRIMARY KEY (STORE_ID,ID))
;

CREATE TABLE AUTH_DB_VERSION(
MAJOR bigint NOT NULL ,
MINOR bigint NOT NULL ,
UPGRADE_STAMP datetime NOT NULL  DEFAULT CURRENT_TIMESTAMP ,
PRIMARY KEY (MAJOR,MINOR))
;

ALTER TABLE SRI_USER ADD CONSTRAINT FK_USER_DEFAULT_STORE FOREIGN KEY (DEFAULT_STORE_ID) REFERENCES MS_STORE (STORE_ID)
;

ALTER TABLE USER_PERMISSION ADD CONSTRAINT FK_USER_PERMISSION_USER FOREIGN KEY (ID) REFERENCES SRI_USER (ID)
ON DELETE CASCADE
;

ALTER TABLE USER_PERMISSION ADD CONSTRAINT FK_USER_PERMISSION_RULE FOREIGN KEY (RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
ON DELETE CASCADE
;

ALTER TABLE ACCESS_RULE_IMPLICIT ADD CONSTRAINT FK_PARENT_RULE FOREIGN KEY (RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
ON DELETE CASCADE
;

ALTER TABLE ACCESS_RULE_IMPLICIT ADD CONSTRAINT FK_IMPLICIT_RULE FOREIGN KEY (IMPLIES_RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
;

ALTER TABLE MS_STORE_USER ADD CONSTRAINT FK_USER_MS_STORE FOREIGN KEY (ID) REFERENCES SRI_USER (ID)
ON DELETE CASCADE
;

ALTER TABLE MS_STORE_USER ADD CONSTRAINT FK_MS_STORE_USER FOREIGN KEY (STORE_ID) REFERENCES MS_STORE (STORE_ID)
ON DELETE CASCADE
;
IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('INSERT_SRI_USER') AND  OBJECTPROPERTY(id, 'IsProcedure') = 1)
DROP PROC INSERT_SRI_USER
;

CREATE PROCEDURE INSERT_SRI_USER
@p_username varchar(255) ,
@p_password varchar(255) ,
@p_salt varchar(250) ,
@p_algorithm varchar(50) ,
@p_default_store_id varchar(255) ,
@p_pk bigint OUT
AS
BEGIN
	SET NOCOUNT ON;
	SET XACT_ABORT ON;
	DECLARE @starttrancount int;
	SET @starttrancount = @@TRANCOUNT;
	BEGIN TRY
		IF @starttrancount = 0 
			BEGIN TRANSACTION

		INSERT INTO SRI_USER (USERNAME,PASSWORD,SALT,ALGORITHM,DEFAULT_STORE_ID) VALUES (@p_username, @p_password, @p_salt, @p_algorithm, @p_default_store_id);
		set @p_pk = SCOPE_IDENTITY();
	IF @starttrancount = 0
	COMMIT TRANSACTION

	END TRY
	BEGIN CATCH
		DECLARE @ErrorMessage NVARCHAR(4000);
		DECLARE @ErrorSeverity INT;
		DECLARE @ErrorState INT;

		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();
		IF XACT_STATE() <> 0 AND @starttrancount = 0 
			ROLLBACK TRANSACTION
	RAISERROR (@ErrorMessage, -- Message text.
				@ErrorSeverity, -- Severity.
				@ErrorState -- State.
				);
	END CATCH
END

;

